package com.ruoyi.base.area.service;


import com.ruoyi.base.area.domain.SysCnArea;
import com.ruoyi.base.area.domain.bo.SysCnAreaBo;
import com.ruoyi.base.area.domain.vo.SysCnAreaVo;
import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.common.core.page.TableDataInfo;

import com.alibaba.fastjson.JSONObject;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 行政区域Service接口
 *
 * @author ruoyi
 * @date 2023-06-25
 */
public interface ISysCnAreaService {

    /**
     * 查询行政区域
     *
     * @param id 行政区域主键
     * @return 行政区域
     */
    SysCnAreaVo queryById(Long id);

    /**
     * 查询行政区域列表
     *
     * @param bo 行政区域
     * @return 行政区域集合
     */
    TableDataInfo<SysCnAreaVo> queryPageList(SysCnAreaBo bo, PageQuery pageQuery);

    /**
     * 查询行政区域列表
     *
     * @param bo 行政区域
     * @return 行政区域集合
     */
    List<SysCnAreaVo> queryList(SysCnAreaBo bo);

    /**
     * 修改行政区域
     *
     * @param bo 行政区域
     * @return 结果
     */
    Boolean insertByBo(SysCnAreaBo bo);

    /**
     * 修改行政区域
     *
     * @param bo 行政区域
     * @return 结果
     */
    Boolean updateByBo(SysCnAreaBo bo);

    /**
     * 校验并批量删除行政区域信息
     *
     * @param ids     需要删除的行政区域主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    JSONObject getTreeLbs();

    List<SysCnArea> getChildren(String parentCode);

    List<SysCnArea> getPath(String code);

    SysCnArea getByCode(String code);

    SysCnArea getByLabel(Integer level, String label);
    SysCnArea getByValue(String value);

    void refreshPinYi();

    Map<String, List<SysCnArea>> allCity();
}
